var/icons[100]
world
	turf=/turf/Grass
	view=6
mob
	icon='mob.dmi'
	Him
		New()
			walk_rand(src)
			..()
turf
	Grass
		icon='grass.dmi'
atom
	proc
		GetAngle(var/turf/t)
			var/sx=t.x-src.x
			var/sy=t.y-src.y
			var/sz=sqrt(sx*sx+sy*sy)
			if(sz==0)
				sz+=0.1
			var/degrees=arccos(sx/sz)
			if(t.y>src.y) degrees=(360-degrees)
			return degrees
mob
	proc
		CPU()
			if(cputoggle==1)
				src<<"CPU: [world.cpu]<br>World Tick Lag: [world.tick_lag]"
				spawn(10) CPU()
mob
	var
		cputoggle=0
	verb
		CPUToggle()
			if(cputoggle==0)
				cputoggle=1
				CPU()
			else cputoggle=0
		BeamHim()
			var/mob/person
			for(var/mob/M in orange())
				person=M//The target
				break
			var/i=rand(1,100)
			icons[i]=icon('effects.dmi',icon_state="1")//The Image icon
			if(person)
				while(person in range())
					var/an=GetAngle(person.loc)
					var/dist=get_dist(src,person)
					usr.PixelLine(thinnes=5,angle=an,howlong=dist*8,count=30,time=1,ic=i)
					src.dir=get_dir(src,person)
					sleep(1)
atom
	proc
		PixelLine(var/thinnes,var/angle,var/howlong,var/count,var/time,var/ic,var/stop=0,var/add=1)
			var/a=5,var/b=5,var/r=0
			var/check=0
			var/max=howlong
			var/turf/begin=locate(src.x,src.y,src.z)
			var/turf/t=locate(src.x,src.y,src.z)
			if(begin==null||t==null) return
			for(r=0;r<max;r+=add)
				var/pause=0; var/x=a+r*(cos(angle))*thinnes; var/y=b-r*(sin(angle))*thinnes;
				var/image/I=new/image; var/movesx=round((x)/32);var/movesy=round((y)/32)
				x-=movesx*32; y-=movesy*32;var/icon/i=icons[ic]; I.icon=i
				t=locate(begin.x+movesx,begin.y+movesy,begin.z); var/mob/M
				for(var/mob/a2 in range(0,t)) if(a2!=src) M=a2
				if(stop>=1) if(t.density==1) return
				if(stop>=2) for(var/obj/a2 in range(0,t)) if(a2.density==1) return
				if(stop>=3) for(var/mob/a2 in range(0,t)) if(a2.density==1) return
				I.pixel_x=x; I.pixel_y=y
				check+=1
				if(check==count) {pause=1; check=0}
				if(t)
					spawn(time) {t.overlays-=I; del(I)}
					switch(rand(1,1)) if(1) t.overlays+=I
				else del(I)
				sleep(pause)
